 module modfun


    !private

    public :: bigfun,bigfunjac
    contains


    function bigfun(pdimvar,vars)


    use mod_types
    use utils
    use humfun2
    use riskyparam
    use m_refsor
    use MersenneTwister_mod
    use omp_lib 
    
    type(randomNumberSequence) :: randomNumbers
    integer :: pdimvar,seed
    real(dp) :: vars(pdimvar),bigfun

    integer :: jind,jind2,nhk2,info,k,funiter,iperm(nagent),learnmom,jpvt(1),job,infochol
    integer(long) :: seedf
    real(dp) :: funval,fscale,fval,unif_1,unif_2,&
                y(nhk),iparam(7),rparam(7),amat(nhk,nhk),&
                gradvec(nhk),wrk(nhk,9),bigfunval,w_time,rvar,corrab,&
                work(1),diagcovar(nhk),momstat(nmom),switchrate

    real(dp) :: simul_earn(nagent,nper+1),simul_occ(nagent,nper+1),abcovmat(nhk,nhk),&
                humlev(nagent,nhk),weights(nagent,nhk+2),finmat(nagent,13),&
                moccport(nocc,2*nhk),soccport(nocc,nhk),sqmoment(nocc,3),&
                mumatsum(nocc),check86,check91,sqmoment_std(nhk,1),count,myop(nagent,nhk),&
               rngs_store(nagent,nhk+nocc), store(nagent,nhk+nocc),sdcredbyocc(nocc)

    j=1
    
    check86=0.0d+00
    check91=0.0d+00
    
    12  format (F8.2,0(1X,F20.1),1X,I3)
    13  format (F10.5,0(1X,F10.5),1X,I3)
    14  format (F8.3,0(1X,F20.3),1X,I3)
    ! label file for output
        if (exp1 == 0) then
            if (estim_flag == 0) then 
                open(unit=55,FILE='result_unweighted.txt')
            else
                open(unit=55,FILE='result_weighted_cd.txt')
            endif
        else
            if (exp1>0) then
            if (exp1==1) then
        open(unit=55,FILE='result_counterfactual_nouncert.txt')
            else
        open(unit=55,FILE='result_counterfactual_cd.txt')
            endif
        endif
    endif
    ! set number of threads to use 
    call omp_set_num_threads(threads)
    write(*,*) 'Total threads: ', threads
    
    ! check with a matrix that adds up the weights by occ
    mumatsum=vars(1:nocc)+vars(nocc+1:2*nocc)
    
    if (maxval(mumatsum).gt.0.99999.or.minval(mumatsum).lt.1d-5.or.minval(vars(1:41)).lt.1d-9.or.vars(42).lt.-0.3d+00) then
         
            bigfun = 10.0d+12
    
            open( UNIT=1, FILE='estimates.txt', position='append')
    
            write (1,2011) vars,bigfun
    
            close(unit=1)
    
    else
    
             ! ------------------------------------------------------------------------
             ! ---  Variance-Covariance Matrix of abilities shocks
             ! ------------------------------------------------------------------------
             corrab = vars(42)
             abcovmat(1,1) = vars(3*nocc+1)
             abcovmat(1,2) = corrab
             abcovmat(1,3) = corrab
             abcovmat(2,1) = corrab
             abcovmat(2,2) = vars(3*nocc+2)
             abcovmat(2,3) = corrab
             abcovmat(3,1) = corrab
             abcovmat(3,2) = corrab
             abcovmat(3,3) = vars(3*nocc+3)
             ! store the diagonal elements in another vector to normalize the abilities
             ! shocks to have mean 1
             diagcovar(1) = vars(3*nocc+1)
             diagcovar(2) = vars(3*nocc+2)
             diagcovar(3) = vars(3*nocc+3)
             
             ! Cholesky factorize matrix to draw multivariate normal below 
             jpvt(1) = 1 
             job = 0 
             call dchdc(abcovmat,nhk,nhk,work,jpvt,job,infochol)
             
             do i=1,(nhk-1)
                abcovmat((i+1):nhk,i) = 0.0d+00     
             enddo
             
             abcovmat = transpose(abcovmat)
             ! done
             
             
             nhk2 = nhk
             
                 
             ! read seeds for rng 
             w_time = omp_get_wtime ( )
             open(unit=4,file='seeds.txt') 
             
             do k=1,threads
                read(4,*) seedvec(k)
             enddo
             
             close(unit=4)
             
             randomNumbers = new_RandomNumberSequence(seed = 475868)
             do i=1,nagent
             
                ! Draw values for productivity signals. 
                do k=1,nocc
                   unif_1 = getRandomReal(randomNumbers)
                   unif_2 = getRandomReal(randomNumbers)
                   sigmamat(k) = r8_normal_01(unif_1,unif_2)
                enddo
                
                rngs_store(i,nhk+1:nhk+nocc) = sigmamat*vars(3*nocc+4) -&
                                               0.5_dp*vars(3*nocc+4)**2.0_dp 
                
                ! draw abilities for accumulating different types of human capital
                do k=1,nhk
                   unif_1 = getRandomReal(randomNumbers)
                   unif_2 = getRandomReal(randomNumbers)
                   abvec_temp(k) = r8_normal_01(unif_1,unif_2)
                enddo

                rngs_store(i,1:nhk) = matmul(abcovmat,abvec_temp)-0.5_dp*diagcovar    ! substract diagcovar                                    
             
             enddo
             
             ! save draws
             open(unit=11,file='alldraws.txt')
             do i=1,nagent
                write(11,2011) rngs_store(i,:)
             enddo
             close(unit=11)
                
             !$OMP PARALLEL shared(nhk2,humlev,simul_occ,&
             !$OMP simul_earn,weights,abcovmat,seedf,myop)&
             !$OMP private(unif_1,unif_2,seed,info,nthread,&
             !$OMP randomNumbers,niter,y,funval,rparam,iparam,&
             !$OMP jind,jind2,amat,gradvec,wrk,fval)   
              
             nthread = omp_get_thread_num ( ) + 1
             randomNumbers = new_RandomNumberSequence(seed = seedvec(nthread))
             
             ! ---------------------------------------------------------------------
             ! ---  vector of occupational specific shocks standard deviations
             ! ---------------------------------------------------------------------
             
             sigmaocc_vec(1:nocc) = vars(2*nocc+1:3*nocc)
             
             
             ! ---------------------------------------------------------
             ! ----  probability of learning ---------------------------
             ! ---------------------------------------------------------
             
             psi = vars(41)
             
             ! ------------------------------------------------------------------------
             ! ------------  "Production Function" Parameters
             ! ------------------------------------------------------------------------
             
             mumat(1,1) = vars(1)
             mumat(2,1) = vars(2)
             mumat(3,1) = vars(3)
             mumat(4,1) = vars(4)
             mumat(5,1) = vars(5)
             mumat(6,1) = vars(6)
             mumat(7,1) = vars(7)
             mumat(8,1) = vars(8)
             mumat(9,1) = vars(9)
             mumat(10,1) = vars(10)
             mumat(11,1) = vars(11)
             mumat(12,1) = vars(12)
             
             
             mumat(1,2) = vars(13)
             mumat(2,2) = vars(14)
             mumat(3,2) = vars(15)
             mumat(4,2) = vars(16)
             mumat(5,2) = vars(17)
             mumat(6,2) = vars(18)
             mumat(7,2) = vars(19)
             mumat(8,2) = vars(20)
             mumat(9,2) = vars(21)
             mumat(10,2) = vars(22)
             mumat(11,2) = vars(23)
             mumat(12,2) = vars(24)
             
             ! parameter driving the elasticity of substitution
             do i=1,nocc
             if (ces_flag == 0) then
             rhomat(i) = 0.00000000001d+00 ! Cobb-Douglas 
             else
             rhomat(i) = -1.15_dp  ! CES 
             endif
             
             enddo
             
             !$omp do
             
             do niter=1,nagent ! Main loop iteration: (number of agents simulated)
             
                ! initial guesses for optimal portfolios
                y0(1) = 10.000004d+00
                y0(2) = 10.000004d+00
                y0(3) = 10.000004d+00
                
                
                abvec = rngs_store(niter,1:nhk)
                sigmamat = rngs_store(niter,nhk+1:nhk+nocc) 
                
                niter2 = niter 
                nthread2 = nthread
                
                if (exp1==0) then                         
                   !Optimization of agent niter 
                   do k=1,3
                      call optif0(nhk2,nhk2,y0,humcap_test,y,funval,gradvec,info,amat,wrk)
                      y0 = y
                   enddo
                endif
                 
                ycount = y  
                
                !---------------------------------------------------------------------------
                ! --- Here starts the part that one needs to use for the "myopic" experiments
                !---------------------------------------------------------------------------
                
                if (exp1>0) then
                
                   if (exp1==1) then ! state = (sigma + epsilon) = no uncertainty 
                    
                       do itermyo=1,nocc
                       mind = itermyo
                       unif_1 = getRandomReal(randomNumbers)
                       unif_2 = getRandomReal(randomNumbers) 
                       
                       ! Add the occupational shock to the occupational signal...
                       
                       sigmamat(mind) = sigmamat(mind) + r8_normal_01(unif_1,unif_2)*sigmaocc_vec(mind)-0.5_dp*sigmaocc_vec(mind)**2.0
                       
                       do k=1,3
                       call optif0(nhk2,nhk2,y0,humcap_myopic,myop(niter,:),funval,gradvec,info,amat,wrk)       
                       y0 = myop(niter,:) 
                       enddo        
                       
                       funvec(itermyo) = -funval
                       portvec(itermyo,1) = myop(niter,1)
                       portvec(itermyo,2) = myop(niter,2)
                       portvec(itermyo,3) = myop(niter,3)
                       enddo
                       
                       itermyo = maxelem(funvec,nocc) ! pick maximum occupation
                       
                       y=portvec(itermyo,:)
                       mind = itermyo
                       call humcap_myopic(nhk2,y,funval)
                   
                   
                   else   ! specialization to "best" industry
                       ycount = y
                       do itermyo=1,nocc
                           mind = itermyo
                           
                           do k=1,3
                               call optif0(nhk2,nhk2,y0,humcap_myopic,myop(niter,:),funval,gradvec,info,amat,wrk)       
                               y0 = myop(niter,:) 
                           enddo 

                           funvec(itermyo) = -funval
                           portvec(itermyo,1) = myop(niter,1)
                           portvec(itermyo,2) = myop(niter,2)
                           portvec(itermyo,3) = myop(niter,3)
                       enddo
                       
                       itermyo = maxelem(funvec,nocc) ! pick maximum occupation
                       
                       y=portvec(itermyo,:)
                       
                       mind = itermyo
                       call humcap_test(nhk2,y,funval)
                   endif
                
                endif
                
                humlev(niter,:) = y
                weights(niter,1) = y(1)/sum(y)
                weights(niter,2) = y(2)/sum(y)
                weights(niter,3) = y(3)/sum(y)
                weights(niter,4) = sum(y)
                weights(niter,5) = (exp(abvec(1)))*y(1)**2.0_dp+(exp(abvec(2)))*y(2)**2.0_dp+(exp(abvec(3)))*y(3)**2.0_dp
                simul_occ(niter,:) = ivec(:)
                simul_earn(niter,:) = evec(:)
             
              
             enddo
             
             !$OMP end do
             !$omp end parallel
             
             write(*,*) 'TIME :' , omp_get_wtime ( ) - w_time
             write(*,*) 'Optimal portfolios computed...'
               
             
             !-------------------------------------------------------------------------------
             !-- Finmat(:,:) has the occupation index in the first column and earnings
             !-- growth in the second column
             !-------------------------------------------------------------------------------
             
             ! Initialize permutation vector for sorting
             
             do i=1,nagent
                iperm(i) = i
             enddo
             
             learnmom = 0
             do i=1,nagent
                finmat(i,1) = simul_occ(i,1)
                finmat(i,2) = simul_occ(i,nper)
                
                if (simul_occ(i,1).eq.simul_occ(i,2).and.simul_occ(i,2).ne.simul_occ(i,3)) then
                   learnmom = learnmom + 1
                endif
             
             enddo
                  
             !-----------------------------------------------------------------------------------
             !--  Now sort the matrix finmat by the occupation index in 1986
             !-----------------------------------------------------------------------------------
             
             call d_mrgref(finmat(:,1),iperm,nagent)
             call refsor(finmat(:,1)) 
                 
              
             17  format (F10.5,12(1X,F10.5),1X,I3)
             
              
             do i=1,nagent
                
                finmat(i,2:5) = simul_occ(iperm(i),2:5)
                finmat(i,6) = simul_earn(iperm(i),nper)/simul_earn(iperm(i),1)-1.0
                finmat(i,7) = simul_earn(iperm(i),1)
                finmat(i,8:10) = weights(iperm(i),1:3)
                finmat(i,11) =  weights(iperm(i),4)
                finmat(i,12) = simul_earn(iperm(i),nper+1)
                finmat(i,13) = weights(iperm(i),5)
                
                write(55,17) finmat(i,:)
             
             enddo
             
             i=1
             ocount  = 1.0
             j = 1
             do while (j.le.nocc)
                k=0
                accept = 0
                do while (accept==0)
                    if (i.gt.nagent) then
                        accept = 1
                        i=i+1
                    elseif (abs(finmat(i,1)-ocount).lt.1d-5) then
                        accept = 0
                        k= k + 1
                        i = i + 1
                    else
                        accept = 1
                    
                    endif
                
                enddo
                
                i=min(i,nagent+1)
                
                finmat(i-k:i-1,8) = aver(finmat(i-k:i-1,5),k)
                finmat(i-k:i-1,9) = aver(finmat(i-k:i-1,6),k)
                finmat(i-k:i-1,10) = aver(finmat(i-k:i-1,7),k)
                
                
                
                ! This part counts switching rates by occupation
                
                count = 0.0d+00
                do info = i-k,i-1
                
                    if (simul_occ(iperm(info),1).eq.simul_occ(iperm(info),2)) then
                        count = count
                    else
                        count = count + 1.0d+00
                    endif
             
                enddo
             
             
             
                moccport(j,3) = count/real(k) ! Ratio of jumps from 1st to 2nd period by occupation
                sqmoment(j,3) = (moccport(j,3)-data_target(2*nocc+j,1))**2.0d+00 
                
                
                ocount = ocount + 1.0d+00
                j=j+1

             enddo
             
             ! count overall switching rate
             count = 0.0d+00
             do i=1,nagent
                if (simul_occ(i,1).eq.simul_occ(i,2).and.simul_occ(i,2).eq.&
                     simul_occ(i,3).and.simul_occ(i,3).eq.simul_occ(i,4).and.&
                     simul_occ(i,4).eq.simul_occ(i,5)) then
                   count = count +1.0
                else
                
                endif
             enddo
             
             switchrate =  (real(nagent)-count)/real(nagent) 
             
              
             finmat = 0.0d+00
             
             do i=1,nagent
                finmat(i,1) = simul_occ(i,1)
                finmat(i,2) = simul_occ(i,nper)
             enddo
             
             !-----------------------------------------------------------------------------------
             !--  Now sort the matrix finmat by the occupation index in 1991
             !-----------------------------------------------------------------------------------
             
              call d_mrgref(finmat(:,2),iperm,nagent)
              call refsor(finmat(:,2)) 
             
             
             do i=1,nagent
             
                finmat(i,1) = simul_occ(iperm(i),1)
                finmat(i,3) = simul_earn(iperm(i),nper)/simul_earn(iperm(i),1)-1.0
                finmat(i,4) = simul_earn(iperm(i),nper)
                finmat(i,5:7) = weights(iperm(i),1:3)
                finmat(i,8) = weights(iperm(i),4)
             
             enddo
             
             
             meanearn = aver(dlog(finmat(:,4)),nagent)                ! mean earnings
             
             i=1
             ocount  = 1.0
             j = 1
             do while (j.le.nocc)
                k=0
                accept = 0
                
                do while (accept==0)
                    if (i.gt.nagent) then
                        accept = 1
                        i=i+1
                    elseif (abs(finmat(i,2)-ocount).lt.1d-5) then
                        accept = 0
                        k= k + 1
                        i = i + 1
                    
                    else
                    
                        accept = 1
                    endif
                    
                enddo
                
                i=min(i,nagent+1)
                 
                moccport(j,1) = aver(finmat(i-k:i-1,5),k)
                moccport(j,2) = aver(finmat(i-k:i-1,6),k)
                sdcredbyocc(j) = stdev(dlog(finmat(i-k:i-1,8)),k)
                
                if (isnan(moccport(j,3))) then
                    check91=1.0d+00
                endif
                
                sqmoment(j,1) = (moccport(j,1)-data_target(j,1))**2.0d+00  !mean w_H by occ
                sqmoment(j,2) = (moccport(j,2)-data_target(nocc+j,1))**2.0d+00 !mean w_M by occ
                
                
                ocount = ocount + 1.0d+00
                j=j+1

             enddo
             
             
             ! Sqmoment_std keeps track of the standard deviation of portfolio weights for ALL occupations.
             
             sqmoment_std(1,1) = (stdev(finmat(:,5),nagent) - data_target(3*nocc+1,1))**2.0_dp
             sqmoment_std(2,1) = (stdev(finmat(:,6),nagent) - data_target(3*nocc+2,1))**2.0_dp
             sqmoment_std(3,1) = (stdev(finmat(:,7),nagent) - data_target(3*nocc+3,1))**2.0_dp
             
             if (check91.gt.0.0d+00) then
           
                 bigfun = 10.0d+14
             
            else 
               
                momstat(1:nocc) = sqmoment(:,1)
                momstat(nocc+1:2*nocc) = sqmoment(:,2)
                momstat(2*nocc+1:3*nocc) = sqmoment(:,3)
                momstat(3*nocc+1:3*nocc+nhk) = sqmoment_std(:,1)
                momstat(3*nocc+nhk+1) = (stdev(dlog(simul_earn(:,1)),nagent)-data_target(3*nocc+4,1))**2.0_dp
                momstat(3*nocc+nhk+2) = (real(learnmom)/real(nagent)-data_target(41,1))**2.0d+00
                momstat(nmom-3) = (corrcoef(dlog(weights(:,2)*weights(:,4)),dlog(weights(:,3)*weights(:,4)),nagent)-data_target(42,1))**2.0d+00
                momstat(nmom-2) = (corrcoef(dlog(weights(:,1)*weights(:,4)),dlog(weights(:,3)*weights(:,4)),nagent)-data_target(43,1))**2.0d+00
                momstat(nmom-1) = (corrcoef(dlog(weights(:,1)*weights(:,4)),dlog(weights(:,2)*weights(:,4)),nagent)-data_target(44,1))**2.0d+00
                momstat(nmom) = (switchrate - data_target(45,1))**2.0d+00
                bigfun  = sum(momstat*dataweight)
             
             endif
             
             print *,'momstat', bigfun,check86,check91
             
             19  format (F8.4,84(1X,F8.4),1X,I3)
             20  format (F8.4,6(1X,F8.4),1X,I3)
             
             open( UNIT=1, FILE='estimates.txt', position='append')
             
             write (1,2011) vars,bigfun
             
             close(unit=1)
             close(unit=55)
             open( UNIT=4, FILE='moms.txt')
             
             
             do j=1,nocc
                write(4,*) moccport(j,1),data_target(j,1)
             enddo
             do j=1,nocc
                write(4,*) moccport(j,2),data_target(nocc+j,1)
             enddo
             do j=1,nocc
                write(4,*) moccport(j,3),data_target(2*nocc+j,1)
             enddo
             
             write(4,*) stdev(finmat(:,5),nagent) , data_target(3*nocc+1,1)
             write(4,*) stdev(finmat(:,6),nagent) , data_target(3*nocc+2,1)
             write(4,*) stdev(finmat(:,7),nagent) , data_target(3*nocc+3,1)
             write(4,*) stdev(dlog(simul_earn(:,1)),nagent), data_target(3*nocc+4,1)
             write(4,*) real(learnmom)/real(nagent), data_target(41,1)
             write(4,*) corrcoef(dlog(weights(:,2)*weights(:,4)),dlog(weights(:,3)*weights(:,4)),nagent),data_target(42,1)
             write(4,*) corrcoef(dlog(weights(:,1)*weights(:,4)),dlog(weights(:,3)*weights(:,4)),nagent),data_target(43,1)
             write(4,*) corrcoef(dlog(weights(:,1)*weights(:,4)),dlog(weights(:,2)*weights(:,4)),nagent),data_target(44,1)
             write(4,*) switchrate,data_target(45,1)
             write(4,*) sdcredbyocc
              
             
             
             
             close( UNIT=4)
             
             2011 format (47(f15.5))
            
            
            
            endif
            
            end function 



   !        ----------------------------------------------------------------------------------------------------------------
   !        ----------------------------------------------------------------------------------------------------------------
   !        ----------------------------------------- SUBROUTINE USED TO COMPUTE THE JACOBIAN-------------------------------
   !        ----------------------------------------------------------------------------------------------------------------
   !        ----------------------------------------------------------------------------------------------------------------


            subroutine bigfunjac(pdim,ndim,vars,moments)

            use mod_types
            use utils
            use humfun2
            use riskyparam
            use m_refsor
            use MersenneTwister_mod
            use omp_lib 


            integer :: pdim,ndim
            real(dp),intent(in) :: vars(ndim)
            real(dp),intent(out) :: moments(pdim)


             type(randomNumberSequence) :: randomNumbers

            integer :: jind,jind2,nhk2,info,k,funiter,iperm(nagent),learnmom,jpvt(1),job,infochol
            integer(long) :: seedf
            real(dp) :: funval,fscale,fval,unif_1,unif_2,&
                        y(nhk),iparam(7),rparam(7),amat(nhk,nhk),&
                        gradvec(nhk),wrk(nhk,9),bigfunval,w_time,rvar,corrab,&
                        work(1),diagcovar(nhk),momstat(nmom),switchrate

            real(dp) :: simul_earn(nagent,nper+1),simul_occ(nagent,nper+1),abcovmat(nhk,nhk),&
                        humlev(nagent,nhk),weights(nagent,nhk+2),finmat(nagent,13),&
                        moccport(nocc,2*nhk),soccport(nocc,nhk),sqmoment(nocc,3),&
                        mumatsum(nocc),check86,check91,sqmoment_std(nhk,1),count,myop(nagent,nhk),&
                       rngs_store(nagent,nhk+nocc), store(nagent,nhk+nocc),sdcredbyocc(nocc)

            j=1

            check86=0.0d+00
            check91=0.0d+00

12          format (F8.2,0(1X,F20.1),1X,I3)
13          format (F10.5,0(1X,F10.5),1X,I3)
14          format (F8.3,0(1X,F20.3),1X,I3)
            if (exp1 == 0) then
            if (estim_flag == 0) then 
            open(unit=55,FILE='result_unweighted.txt')
            else
            open(unit=55,FILE='result_weighted.txt')
            endif
            else
            open(unit=55,FILE='result_counterfactual.txt')
            endif

            call omp_set_num_threads(threads)
            write(*,*) 'Total threads: ', threads

            ! check with a matrix that adds up the weights by occ
            mumatsum=vars(1:nocc)+vars(nocc+1:2*nocc)


   !         ------------------------------------------------------------------------
   !         ---  Variance-Covariance Matrix of abilities shocks
   !         ------------------------------------------------------------------------
             corrab = vars(42)
             abcovmat(1,1) = vars(3*nocc+1)
             abcovmat(1,2) = corrab
             abcovmat(1,3) = corrab
             abcovmat(2,1) = corrab
             abcovmat(2,2) = vars(3*nocc+2)
             abcovmat(2,3) = corrab
             abcovmat(3,1) = corrab
             abcovmat(3,2) = corrab
             abcovmat(3,3) = vars(3*nocc+3)
             ! store the diagonal elements in another vector to normalize the abilities
             ! shocks to have mean 1
             diagcovar(1) = vars(3*nocc+1)
             diagcovar(2) = vars(3*nocc+2)
             diagcovar(3) = vars(3*nocc+3)

             ! Cholesky factorize matrix to draw multivariate normal below 
             jpvt(1) = 1 
             job = 0 
             call dchdc(abcovmat,nhk,nhk,work,jpvt,job,infochol)
             do i=1,(nhk-1)
             abcovmat((i+1):nhk,i) = 0.0d+00     
             enddo
             abcovmat = transpose(abcovmat)
             ! done
            

             nhk2 = nhk

                 
             ! read seeds for rng 
             w_time = omp_get_wtime ( )
             open(unit=4,file='seeds.txt') 
             do k=1,threads
             read(4,*) seedvec(k)
             enddo
             close(unit=4)

             randomNumbers = new_RandomNumberSequence(seed = 475868)
             do i=1,nagent
             ! Draw values for productivity signals. 
             do k=1,nocc
             unif_1 = getRandomReal(randomNumbers)
             unif_2 = getRandomReal(randomNumbers)
             sigmamat(k) = r8_normal_01(unif_1,unif_2)
             enddo
             rngs_store(i,nhk+1:nhk+nocc) = sigmamat*vars(3*nocc+4) - 0.5_dp*vars(3*nocc+4)**2.0_dp 
             
!             ! draw abilities for accumulating different types of human capital

              do k=1,nhk
              unif_1 = getRandomReal(randomNumbers)
              unif_2 = getRandomReal(randomNumbers)
              abvec_temp(k) = r8_normal_01(unif_1,unif_2)
              enddo
              rngs_store(i,1:nhk) = matmul(abcovmat,abvec_temp)-0.5_dp*diagcovar    ! substract diagcovar                                                                         ! the mean of the normal is
                                                                      ! -0.5*variance()

             enddo
             
             open(unit=11,file='alldraws.txt')
             do i=1,nagent
             write(11,2011) rngs_store(i,:)
             enddo
             close(unit=11)
              
   !$OMP PARALLEL shared(nhk2,humlev,simul_occ,&
   !$OMP simul_earn,weights,abcovmat,seedf,myop)&
   !$OMP private(unif_1,unif_2,seed,info,nthread,&
   !$OMP randomNumbers,niter,y,funval,rparam,iparam,jind,jind2,amat,gradvec,wrk,fval)   
            
            nthread = omp_get_thread_num ( ) + 1

            ! ---------------------------------------------------------------------
            ! ---  vector of occupational specific shocks standard deviations
            ! ---------------------------------------------------------------------

            sigmaocc_vec(1:nocc) = vars(2*nocc+1:3*nocc)


             ! ---------------------------------------------------------
             ! ----  probability of learning ---------------------------
             ! ---------------------------------------------------------

             psi = vars(41)

            ! ------------------------------------------------------------------------
            ! ------------  "Production Function" Parameters
            ! ------------------------------------------------------------------------

             mumat(1,1) = vars(1)
             mumat(2,1) = vars(2)
             mumat(3,1) = vars(3)
             mumat(4,1) = vars(4)
             mumat(5,1) = vars(5)
             mumat(6,1) = vars(6)
             mumat(7,1) = vars(7)
             mumat(8,1) = vars(8)
             mumat(9,1) = vars(9)
             mumat(10,1) = vars(10)
             mumat(11,1) = vars(11)
             mumat(12,1) = vars(12)


             mumat(1,2) = vars(13)
             mumat(2,2) = vars(14)
             mumat(3,2) = vars(15)
             mumat(4,2) = vars(16)
             mumat(5,2) = vars(17)
             mumat(6,2) = vars(18)
             mumat(7,2) = vars(19)
             mumat(8,2) = vars(20)
             mumat(9,2) = vars(21)
             mumat(10,2) = vars(22)
             mumat(11,2) = vars(23)
             mumat(12,2) = vars(24)
             
             ! parameter driving the elasticity of substitution
             do i=1,nocc
                if (ces_flag == 0) then
             rhomat(i) = 0.00000000001d+00 ! Cobb-Douglas 
                else
             rhomat(i) = -1.15_dp  ! CES 
                endif

             enddo
            
             !$omp do

             do niter=1,nagent ! Main loop iteration: (number of agents simulated)

              ! initial guesses for optimal portfolios
             y0(1) = 10.000004d+00
             y0(2) = 10.000004d+00
             y0(3) = 10.000004d+00

                                                                      ! -0.5*variance()
              !Optimization of agent niter 
              abvec = rngs_store(niter,1:nhk)
              sigmamat = rngs_store(niter,nhk+1:nhk+nocc) 
            
              niter2 = niter 
              nthread2 = nthread
              
              !Optimization of agent niter 
              k = 1
           
              do k=1,3
              call optif0(nhk2,nhk2,y0,humcap_test,y,funval,gradvec,info,amat,wrk)
              y0 = y
       
              enddo
             
              
              humlev(niter,:) = y

             weights(niter,1) = y(1)/sum(y)
             weights(niter,2) = y(2)/sum(y)
             weights(niter,3) = y(3)/sum(y)
             weights(niter,4) = sum(y)
             weights(niter,5) = (exp(abvec(1)))*y(1)**2.0_dp+(exp(abvec(2)))*y(2)**2.0_dp+(exp(abvec(3)))*y(3)**2.0_dp
             simul_occ(niter,:) = ivec(:)
             simul_earn(niter,:) = evec(:)
            
            if (minval(evec(:)).lt.0.0d+00) then
            write(*,*) 'POBLEMA!!!',niter
            pause
            write(*,*) 'POBLEMA!!!',evec
            pause
            endif

            

           enddo

           !$OMP end do
           !$omp end parallel
             
            write(*,*) 'TIME :' , omp_get_wtime ( ) - w_time
            write(*,*) 'Optimal portfolios computed...'
             

            !-------------------------------------------------------------------------------
            !-- Finmat(:,:) has the occupation index in the first column and earnings
            !-- growth in the second column
            !-------------------------------------------------------------------------------

            ! Initialize permutation vector for sorting

            do i=1,nagent
                iperm(i) = i
            enddo

            learnmom = 0
            do i=1,nagent
            finmat(i,1) = simul_occ(i,1)
            finmat(i,2) = simul_occ(i,nper)
            
            if (simul_occ(i,1).eq.simul_occ(i,2).and.simul_occ(i,2).ne.simul_occ(i,3)) then
            learnmom = learnmom + 1
            endif

            enddo
                 
            !-----------------------------------------------------------------------------------
            !--  Now sort the matrix finmat by the occupation index in 1986
            !-----------------------------------------------------------------------------------

            call d_mrgref(finmat(:,1),iperm,nagent)
            call refsor(finmat(:,1)) 
           
        
            17  format (F10.5,12(1X,F10.5),1X,I3)
      
        
            do i=1,nagent
               
                finmat(i,2:5) = simul_occ(iperm(i),2:5)
                finmat(i,6) = simul_earn(iperm(i),nper)/simul_earn(iperm(i),1)-1.0
                finmat(i,7) = simul_earn(iperm(i),1)
                finmat(i,8:10) = weights(iperm(i),1:3)
                finmat(i,11) =  weights(iperm(i),4)
                finmat(i,12) = simul_earn(iperm(i),nper+1)
                finmat(i,13) = weights(iperm(i),5)

            write(55,17) finmat(i,:)
             
            enddo
            i=1
            ocount  = 1.0
            j = 1
            do while (j.le.nocc)
                k=0
                accept = 0
                do while (accept==0)
                    
                    if (i.gt.nagent) then
                        accept = 1
                        i=i+1
                    elseif (abs(finmat(i,1)-ocount).lt.1d-5) then
                        accept = 0
                        k= k + 1
                        i = i + 1
                    else
                        accept = 1

                    endif

                enddo

                i=min(i,nagent+1)
        
                finmat(i-k:i-1,8) = aver(finmat(i-k:i-1,5),k)
                finmat(i-k:i-1,9) = aver(finmat(i-k:i-1,6),k)
                finmat(i-k:i-1,10) = aver(finmat(i-k:i-1,7),k)
        


                ! This part counts switching rates by occupation

                count = 0.0d+00
                do info = i-k,i-1
                    if (simul_occ(iperm(info),1).eq.simul_occ(iperm(info),2)) then
                        count = count
                    else
                        count = count + 1.0d+00
                    endif

                enddo



                moccport(j,3) = count/real(k) ! Ratio of jumps from 1st to 2nd period by occupation
                sqmoment(j,3) = (moccport(j,3)-data_target(2*nocc+j,1))**2.0d+00 


                ocount = ocount + 1.0d+00
                j=j+1
            enddo
            
            ! count overall switching rate
            count = 0.0d+00
            do i=1,nagent
                if (simul_occ(i,1).eq.simul_occ(i,2).and.simul_occ(i,2).eq.&
                    simul_occ(i,3).and.simul_occ(i,3).eq.simul_occ(i,4).and.&
                    simul_occ(i,4).eq.simul_occ(i,5)) then
      
                    count = count +1.0
                else

                endif

            enddo
            switchrate =  (real(nagent)-count)/real(nagent) 

      
            finmat = 0.0d+00

            do i=1,nagent
                finmat(i,1) = simul_occ(i,1)
                finmat(i,2) = simul_occ(i,nper)
            enddo

            !-----------------------------------------------------------------------------------
            !--  Now sort the matrix finmat by the occupation index in 1991
            !-----------------------------------------------------------------------------------

            call d_mrgref(finmat(:,2),iperm,nagent)
            call refsor(finmat(:,2)) 
 

            do i=1,nagent

                finmat(i,1) = simul_occ(iperm(i),1)
                finmat(i,3) = simul_earn(iperm(i),nper)/simul_earn(iperm(i),1)-1.0
                finmat(i,4) = simul_earn(iperm(i),nper)
                finmat(i,5:7) = weights(iperm(i),1:3)
                finmat(i,8) = weights(iperm(i),4)

            enddo


            meanearn = aver(dlog(finmat(:,4)),nagent)                ! mean earnings

            i=1
            ocount  = 1.0
            j = 1
            do while (j.le.nocc)
                k=0
                accept = 0
                do while (accept==0)
                    
                    if (i.gt.nagent) then
                   
                        accept = 1
                        i=i+1
                    
                    elseif (abs(finmat(i,2)-ocount).lt.1d-5) then
                        
                        accept = 0
                        k= k + 1
                        i = i + 1

                    else

                        accept = 1
                    
                    endif

                enddo

                i=min(i,nagent+1)


                moccport(j,1) = aver(finmat(i-k:i-1,5),k)
                moccport(j,2) = aver(finmat(i-k:i-1,6),k)
                sdcredbyocc(j) = stdev(dlog(finmat(i-k:i-1,8)),k)

                if (isnan(moccport(j,3))) then
                    check91=1.0d+00
                endif

                sqmoment(j,1) = (moccport(j,1)-data_target(j,1))**2.0d+00  !mean w_H by occ
                sqmoment(j,2) = (moccport(j,2)-data_target(nocc+j,1))**2.0d+00 !mean w_M by occ


                ocount = ocount + 1.0d+00
                j=j+1
            enddo


            ! Sqmoment_std keeps track of the standard deviation of portfolio weights for ALL occupations.

            sqmoment_std(1,1) = (stdev(finmat(:,5),nagent) - data_target(3*nocc+1,1))**2.0_dp
            sqmoment_std(2,1) = (stdev(finmat(:,6),nagent) - data_target(3*nocc+2,1))**2.0_dp
            sqmoment_std(3,1) = (stdev(finmat(:,7),nagent) - data_target(3*nocc+3,1))**2.0_dp
           
            moments(1:nocc) = sqmoment(:,1)
            moments(nocc+1:2*nocc) = sqmoment(:,2)
            moments(2*nocc+1:3*nocc) = sqmoment(:,3)
            moments(3*nocc+1:3*nocc+nhk) = sqmoment_std(:,1)
            moments(3*nocc+nhk+1) = stdev(dlog(simul_earn(:,1)),nagent)
            moments(3*nocc+nhk+2) = real(learnmom)/real(nagent)
            moments(nmom-3) = corrcoef(dlog(weights(:,2)*weights(:,4)),dlog(weights(:,3)*weights(:,4)),nagent)
            moments(nmom-2) = corrcoef(dlog(weights(:,1)*weights(:,4)),dlog(weights(:,3)*weights(:,4)),nagent)      
            moments(nmom-1) =  corrcoef(dlog(weights(:,1)*weights(:,4)),dlog(weights(:,2)*weights(:,4)),nagent)
            moments(nmom) = switchrate 

            2011 format (47(f15.5))
            open( UNIT=1, FILE='jacobian_vars_moments.txt', position='append')

            write (1,2011) vars,moments

            close(unit=1)


    end subroutine

   end module modfun
