
module riskyparam
use mod_types
use omp_lib
use MersenneTwister_mod

implicit none

   integer, parameter :: nocc=12,&
                         nagent=5000,&
                         nper=5,nhk=3,&
                         mcdraws=200,&
                         threads=24,&
                         nvar=42,&
                         one=1d+00,&
                         nmom=45,& 
                         ntdraws=200

   real(dp), parameter :: pi = 3.14159265_dp,&  
             gamma =1.04588d+00,&
             betam=0.96/gamma

   real (dp) :: sigmamat(nocc),rhomat(nocc),mumat(nocc,nhk-1),&
                sigmaocc_vec(nocc),dataweight(nmom),&
                data_target(nmom,1),abvec(nhk),evec(nper+1),&
                shockmat(nocc),mgit,sgit,income,&
                laborocc2(mcdraws,nocc+1),laborearn2(mcdraws,nocc+1),&
                portvec(nocc,nhk),funvec(nocc),psi,abvec_temp(nhk),&
                ycount(nhk),y0(nhk)

   integer :: i,j, irank, niter, accept,mcniter,ivec(nper+1),&
       niter2,seedvec(threads),mind,itermyo,exp1,ces_flag,&
       estim_flag,nthread,seed_m,nthread2

   !$OMP THREADPRIVATE(sigmamat,abvec,ivec,evec,mumat,&
   !$OMP rhomat,sigmaocc_vec,niter2,nthread2,mgit,sgit,psi,&
   !$OMP income,laborocc2,laborearn2,shockmat,mind,itermyo,&
   !$OMP portvec,funvec,abvec_temp,seed_m,ycount,y0)

end module riskyparam
