# Estimate regressions without including major (Regressions 1-4)
# Regression 1
yfm <- lm(log(wage91)~1 + lwinit + lcredits + SEX + diver_measure + 
          overall_gpa + dummy(relab_occ_91) + dummy(NHDEG),data=test)

zmat <- cbind(coef(summary(yfm))[,1],coef(summary(yfm))[,3],
              round_any(dim(test)[1],10),summary(yfm)$r.squared,
              coef(summary(yfm))[,4])

write.table(zmat,file=paste0(pathtodir,"reg1_",filename),sep=",")
print(summary(yfm))

# Regression 2  
yfm <- lm(log(wage91)~1 + lwinit + lcredits + SEX + diver_measure + 
          istay + overall_gpa + dummy(relab_occ_91) + dummy(NHDEG),data=test)
zmat <- cbind(coef(summary(yfm))[,1],coef(summary(yfm))[,3],
              round_any(dim(test)[1],10),summary(yfm)$r.squared,
              coef(summary(yfm))[,4])

write.table(zmat,file=paste0(pathtodir,"reg2_",filename),sep=",")
print(summary(yfm))

# Regression 3
yfm <- lm(log(wage91)~1 + lwinit + lcredits + SEX + diver_measure + 
          istay + icareer + overall_gpa + dummy(relab_occ_91)+dummy(NHDEG),data=test)
zmat <- cbind(coef(summary(yfm))[,1],coef(summary(yfm))[,3],
              round_any(dim(test)[1],10),summary(yfm)$r.squared,
              coef(summary(yfm))[,4])

write.table(zmat,file=paste0(pathtodir,"reg3_",filename),sep=",")
print(summary(yfm))

# Regression 4
yfm <- lm(log(wage91)~1 + lwinit + lcredits + SEX + diver_measure +
          istay + icareer + istay.diver + overall_gpa + dummy(relab_occ_91) + dummy(NHDEG),data=test)
zmat <- cbind(coef(summary(yfm))[,1],coef(summary(yfm))[,3],
              round_any(dim(test)[1],10),summary(yfm)$r.squared,
              coef(summary(yfm))[,4])

write.table(zmat,file=paste0(pathtodir,"reg4_",filename),sep=",")
print(summary(yfm))
print(dim(test))

# Estimate Probit regressions without including major (Probit Regressions 1-4)
# Probit Regression 1
myprobit <- glm(istay~ diver_measure + overall_gpa + dummy(relab_occ_91) + dummy(NHDEG),
                family=binomial(link="probit"), data=test, na.action=na.pass)
zmat <- cbind(coef(summary(myprobit))[,1],coef(summary(myprobit))[,3],
              round_any(dim(test)[1],10),summary(myprobit)$r.squared,coef(summary(myprobit))[,4])
write.table(zmat,file=paste0(pathtodir,"probit1_",filename),sep=",")

# Probit Regression 2 
myprobit<- glm(istay~ diver_measure + lwinit + overall_gpa + dummy(relab_occ_91) +
               dummy(NHDEG), family=binomial(link="probit"), data=test, na.action=na.pass)
zmat <- cbind(coef(summary(myprobit))[,1],coef(summary(myprobit))[,3],
              round_any(dim(test)[1],10),summary(myprobit)$r.squared,coef(summary(myprobit))[,4])
write.table(zmat,file=paste0(pathtodir,"probit2_",filename),sep=",")

# Probit Regression 3 
myprobit<- glm(istay~ diver_measure + lwinit + lcredits + overall_gpa + 
               dummy(relab_occ_91) + dummy(NHDEG), family=binomial(link="probit"), data=test, na.action=na.pass)
zmat <- cbind(coef(summary(myprobit))[,1],coef(summary(myprobit))[,3],
          round_any(dim(test)[1],10),summary(myprobit)$r.squared,coef(summary(myprobit))[,4])
write.table(zmat,file=paste0(pathtodir,"probit3_",filename),sep=",")

# Probit Regression 4 
myprobit<- glm(istay~ diver_measure + lwinit + lcredits + SEX +
               overall_gpa + dummy(relab_occ_91) + dummy(NHDEG), 
               family=binomial(link="probit"), data=test, na.action=na.pass)
zmat <- cbind(coef(summary(myprobit))[,1],coef(summary(myprobit))[,3],
              round_any(dim(test)[1],10),summary(myprobit)$r.squared,coef(summary(myprobit))[,4])
write.table(zmat,file=paste0(pathtodir,"probit4_",filename),sep=",")


