##---------------------------------------------------------------------------------------
## --- Recode Major 
##---------------------------------------------------------------------------------------
#
test<-test[test$MAJUG1>0&test$MAJUG1<999,]

test$major <- 17 
test$major <- ifelse((test$MAJUG1>0&test$MAJUG1<=40),1,test$major)
test$major <- ifelse(test$MAJUG1==60,2,test$major)
test$major <- ifelse(test$MAJUG1==61,3,test$major)
test$major <- ifelse(test$MAJUG1==62,4,test$major)
test$major <- ifelse(test$MAJUG1==63,5,test$major)
test$major <- ifelse(test$MAJUG1>=90&test$MAJUG1<=100,6,test$major)
test$major <- ifelse(test$MAJUG1>=110&test$MAJUG1<=112,7,test$major)
test$major <- ifelse(test$MAJUG1>=130&test$MAJUG1<=135,8,test$major)
test$major <- ifelse(test$MAJUG1>=140&test$MAJUG1<=150,9,test$major)
test$major <- ifelse(test$MAJUG1>=160&test$MAJUG1<=162,10,test$major)
test$major <- ifelse(test$MAJUG1>=170&test$MAJUG1<=190,11,test$major)
test$major <- ifelse(test$MAJUG1>=230&test$MAJUG1<=240,12,test$major)
test$major <- ifelse((test$MAJUG1>=400&test$MAJUG1<=403)|
                     test$MAJUG1>=260&test$MAJUG1<=271,13,test$major)
test$major <- ifelse(test$MAJUG1==451,14,test$major)
test$major <- ifelse((test$MAJUG1>=452&test$MAJUG1<=456)|
                     test$MAJUG1==450,15,test$major)
test$major <- ifelse(test$MAJUG1>=500&test$MAJUG1<=505,16,test$major)


print(table(test$major))

# Regression 1
yfm <- lm(log(wage91)~1 + lwinit + lcredits + SEX + diver_measure +
          overall_gpa + dummy(major) + dummy(relab_occ_91) + dummy(NHDEG),data = test)
zmat <- cbind(coef(summary(yfm))[,1],coef(summary(yfm))[,3],
              round_any(dim(test)[1],10),summary(yfm)$r.squared,coef(summary(yfm))[,4])

write.table(zmat,file=paste0(pathtodir,"reg1_",filename),sep=",")
print(summary(yfm))

# Regression 2 
yfm <- lm(log(wage91)~1 + lwinit + lcredits + SEX + diver_measure + 
          istay + overall_gpa + dummy(major) + dummy(relab_occ_91) + 
          dummy(NHDEG),data = test)
zmat <-  cbind(coef(summary(yfm))[,1],coef(summary(yfm))[,3],
               round_any(dim(test)[1],10),summary(yfm)$r.squared,
               coef(summary(yfm))[,4])

write.table(zmat,file=paste0(pathtodir,"reg2_",filename),sep=",")
print(summary(yfm))

# Regression 3
yfm <-
    lm(log(wage91)~1+lwinit+lcredits+SEX+diver_measure+istay+icareer+overall_gpa+dummy(major)+dummy(relab_occ_91)+dummy(NHDEG),data=test)
zmat <-  cbind(coef(summary(yfm))[,1],coef(summary(yfm))[,3],round_any(dim(test)[1],10),summary(yfm)$r.squared,coef(summary(yfm))[,4])

write.table(zmat,file=paste0(pathtodir,"reg3_",filename),sep=",")
print(summary(yfm))
yfm <-
    lm(log(wage91)~1+lwinit+lcredits+SEX+diver_measure+istay+icareer+istay.diver+overall_gpa+dummy(major)+dummy(relab_occ_91)+dummy(NHDEG),data=test)
zmat <-  cbind(coef(summary(yfm))[,1],coef(summary(yfm))[,3],round_any(dim(test)[1],10),summary(yfm)$r.squared,coef(summary(yfm))[,4])


write.table(zmat,file=paste0(pathtodir,"reg4_",filename),sep=",")
print(summary(yfm))

myprobit<- glm(istay~
               diver_measure+overall_gpa+dummy(major)+dummy(relab_occ_91)+dummy(NHDEG),family=binomial(link="probit"), data=test, na.action=na.pass)
zmat <-
    cbind(coef(summary(myprobit))[,1],coef(summary(myprobit))[,3],round_any(dim(test)[1],10),summary(myprobit)$r.squared,coef(summary(myprobit))[,4])
write.table(zmat,file=paste0(pathtodir,"probit1_",filename),sep=",")

myprobit<- glm(istay~ diver_measure+lwinit+overall_gpa+dummy(major)+dummy(relab_occ_91)+dummy(NHDEG), family=binomial(link="probit"), data=test, na.action=na.pass)
zmat <-
    cbind(coef(summary(myprobit))[,1],coef(summary(myprobit))[,3],round_any(dim(test)[1],10),summary(myprobit)$r.squared,coef(summary(myprobit))[,4])
write.table(zmat,file=paste0(pathtodir,"probit2_",filename),sep=",")

myprobit<- glm(istay~ diver_measure+lwinit+lcredits+overall_gpa+dummy(major)+dummy(relab_occ_91)+dummy(NHDEG), family=binomial(link="probit"), data=test, na.action=na.pass)
zmat <-
    cbind(coef(summary(myprobit))[,1],coef(summary(myprobit))[,3],round_any(dim(test)[1],10),summary(myprobit)$r.squared,coef(summary(myprobit))[,4])
write.table(zmat,file=paste0(pathtodir,"probit3_",filename),sep=",")

myprobit<- glm(istay~ diver_measure+lwinit+lcredits+SEX+overall_gpa+dummy(major)+dummy(relab_occ_91)+dummy(NHDEG), family=binomial(link="probit"), data=test, na.action=na.pass)
zmat <-
    cbind(coef(summary(myprobit))[,1],coef(summary(myprobit))[,3],round_any(dim(test)[1],10),summary(myprobit)$r.squared,coef(summary(myprobit))[,4])
write.table(zmat,file=paste0(pathtodir,"probit4_",filename),sep=",")
##

