        # include also the arts-related stuff 
        if (with_arts_indicator==1) {myvars <- c(myvars,"w_fpa","fpa_cred")}
        
        test <- alldata2[myvars]
        
        # sex defined as 1=male 2=female. Set to 0,1
        test$SEX <- test$SEX-1
        dim(test)
        
        test<-na.omit(test)
        summary(test)
        print('Size Prior to Chopping Off top and bottom 2% and eliminating
              those graduating late')
        print(dim(test))
        
        test$math_cred<-ifelse(test$math_cred==0,1,test$math_cred)
        test$hum_cred<-ifelse(test$hum_cred==0,1,test$hum_cred)
        test$socsci_cred<-ifelse(test$socsci_cred==0,1,test$socsci_cred)

        # define total credits 
        if (with_arts_indicator==1) {
            
            test$fpa_cred<-ifelse(test$fpa_cred==0,1,test$fpa_cred)
            test$totcred<-test$math_cred+test$hum_cred+test$socsci_cred + test$fpa_cred 

        } else {

            test$totcred<-test$math_cred+test$hum_cred+test$socsci_cred
        }
        
        # weight credits by GPA
        
        test$wmath_cred<-test$math_cred*test$gpa_q
        test$wmath_cred<-ifelse(test$wmath_cred==0,1,test$wmath_cred)
        test$whum_cred<-test$hum_cred*test$gpa_h
        test$whum_cred<-(test$hum_cred)*test$gpa_h
        test$whum_cred<-ifelse(test$whum_cred==0,1,test$whum_cred)
        test$wsocsci_cred<-test$socsci_cred*test$gpa_bc
        test$wsocsci_cred<-ifelse(test$wsocsci_cred==0,1,test$wsocsci_cred)
        
        test$wcredits<-test$wmath_cred+test$whum_cred+test$wsocsci_cred
        
        test = test[test$DEGYEAR<=90,]
        
        print('Eliminate Those graduating >=1990')
        print(dim(test))
        
        #---------------------------------------------------------------------------------------
        #---------------------------------------------------------------------------------------
        
        #now compute growth rate of income and labor market history taking into
        #account degree and year of graduation
        
        test$occinit <- test$relab_occ_86 
        test$occinit<-ifelse(test$DEGYEAR<=85,test$relab_occ_86,test$occinit)
        test$occinit<-ifelse(test$DEGYEAR==86,test$relab_occ_87,test$occinit)
        test$occinit<-ifelse(test$DEGYEAR==87,test$relab_occ_88,test$occinit)
        test$occinit<-ifelse(test$DEGYEAR==88,test$relab_occ_89,test$occinit)
        
        summary(test$occinit)
        
        test$occend <- test$relab_occ_91
        
        test$wageinit <- test$wage86 
        test$wageinit<-ifelse(test$DEGYEAR<=85,test$wage86,test$wageinit)
        test$wageinit<-ifelse(test$DEGYEAR==86,test$wage87,test$wageinit)
        test$wageinit<-ifelse(test$DEGYEAR==87,test$wage88,test$wageinit)
        test$wageinit<-ifelse(test$DEGYEAR==88,test$wage89,test$wageinit)
        
        test$ydata <-  exp(log(test$wage91/test$wageinit)/5)-1
        test$ydata<-ifelse(test$DEGYEAR<=85,exp(log(test$wage91/test$wageinit)/5)-1,test$ydata)
        test$ydata<-ifelse(test$DEGYEAR==86,exp(log(test$wage91/test$wageinit)/4)-1,test$ydata)
        test$ydata<-ifelse(test$DEGYEAR==87,exp(log(test$wage91/test$wageinit)/3)-1,test$ydata)
        test$ydata<-ifelse(test$DEGYEAR==88,exp(log(test$wage91/test$wageinit)/2)-1,test$ydata)
        
        #---------------------------------------------------------------------------------------
        #-------------------------------------------------------------------------------------
        
        # Winsorize earnings growth distribution
        
        test<-test[test$ydata>quantile(test$ydata,0.005),]
        test<-test[test$ydata<quantile(test$ydata,0.995),]
        
        print('Chop off distribution top and bottom 2%')
        print(dim(test))
        
        # Compute switching variable for each individual, taking into account
        # the length of her labor market history (using DEGYEAR).
        
        test$istay85 <- ifelse((test$DEGYEAR<=85)&(test$relab_occ_86==test$relab_occ_87)&
        (test$relab_occ_87==test$relab_occ_88)&(test$relab_occ_88==test$relab_occ_89)&
        (test$relab_occ_89==test$relab_occ_90)&(test$relab_occ_90==test$relab_occ_91),1,0)
        
        test$istay86 <- ifelse((test$DEGYEAR==86)&(test$relab_occ_87==test$relab_occ_88)&
        (test$relab_occ_87==test$relab_occ_88)&(test$relab_occ_88==test$relab_occ_89)&
        (test$relab_occ_89==test$relab_occ_90)&(test$relab_occ_90==test$relab_occ_91),1,0)
        
        test$istay87 <- ifelse((test$DEGYEAR==87)&(test$relab_occ_88==test$relab_occ_89)&
        (test$relab_occ_89==test$relab_occ_90)&(test$relab_occ_90==test$relab_occ_91),1,0)
        
        test$istay88 <- ifelse((test$DEGYEAR==88)&
        (test$relab_occ_89==test$relab_occ_90)&(test$relab_occ_90==test$relab_occ_91),1,0)
        
        # indicator of switching for an individual ls. 
        
        test$istay <- test$istay85+test$istay86+test$istay87+test$istay88
        summary(test$istay)
        
        test_noswitch <- test[test$istay==1,] # use this dataset to compute
                                              # average portfolios of
                                              # well-matched individuals (i.e. those that do not move)
        
        # Eliminate legal and physicians (see online appendix to the paper for
        # details.
        
        test<-test[test$occinit!=7,]
        test<-test[test$occinit!=8,]
        test<-test[test$relab_occ_91!=7,]
        test<-test[test$relab_occ_91!=8,]
        
        
        print('Eliminate Occs. 7 and 8.')
        print(dim(test))
        
        if (with_arts_indicator==1){
            
            print(dim(test))
            aggport_art<-summaryBy(w_hum+w_math+w_socsci+w_fpa~relab_occ_91,data=test_noswitch,FUN=c(mean,sd))
            
            aggport_art$occinit <- aggport_art$relab_occ_91
            aggport_art<-aggport_art[,(2:10)]
            
            # MERGE THE TWO DATATSETS
            test<-merge(test,aggport_art,by.x = "occinit",by.y = "occinit")
            print(dim(test))
            
            test$diver_measure <- sqrt( (test$w_hum.mean-test$w_hum)^2 + 
            (test$w_math.mean-test$w_math)^2 + 
            (test$w_socsci.mean-test$w_socsci)^2 +(test$w_fpa.mean-test$w_fpa)^2) 
        
        } else {
            
            aggport_noart<-summaryBy(w_hum+w_math+w_socsci~relab_occ_91,data=test_noswitch,FUN=c(mean,sd))
            
            aggport_noart$occinit <- aggport_noart$relab_occ_91
            aggport_noart<-aggport_noart[,(2:8)]
            
            # MERGE THE TWO DATATSETS
            test<-merge(test,aggport_noart,by.x = "occinit",by.y = "occinit")
            
            test$diver_measure <- sqrt( (test$w_hum.mean-test$w_hum)^2 + 
            (test$w_math.mean-test$w_math)^2 + 
            (test$w_socsci.mean-test$w_socsci)^2)
        
        }
        # define log credits
        test$lcredits <- log(test$totcred)
        # define log of initial wage
        test$lwinit <- log(test$wageinit)
        print(dim(test))
         
        # define CAREER
        test$icareer <- ifelse((test$occinit==1 & 
                                test$relab_occ_91==2)|
                               (test$occinit==1 & 
                                test$relab_occ_91==9)| 
                               (test$occinit==9 & 
                                test$relab_occ_91==2)|
                               (test$occinit==6 & 
                                test$relab_occ_91==2)|
                               (test$occinit==11 & 
                                test$relab_occ_91==2)
                               ,1,0)
        
        # define interaction variables
        test$istay.diver <- test$istay*test$diver_measure
        test$icareer.diver<-test$icareer*test$diver_measure

